set names WIN1251;
set CLIENTLIB 'fbclient.dll';
connect 'd:\Smarket.fdb' user 'sysdba' password '3';

insert into scripts(name, makedate, developer, comment1)
  values('FB1401_quart_18_4_add1.sql', '31.12.2018', 14, '       IV  2018 ');


set term ^ ;

execute block 
as 
begin 
  execute statement 'grant usage on exception E_OPRETGROUP_TWO_SAME to public';
  execute statement 'GRANT USAGE ON SEQUENCE AXAPTA_DATE_GEN TO PUBLIC';
  when any do
    post_event 'none'; 
end^

create or alter procedure AXAPTA_IMPDOCHEADER (
    STAGE_ID T_FID)
returns (
    DOCHEADERID T_FID,
    OPERATIONTYPEID T_FID,
    DOCFLOWID T_FID,
    STOREID T_FID,
    DOCNUM T_STR20,
    DOCDATE T_DATE_NULL,
    CONTRAGENTID T_FID,
    LOCATIONIDFROM T_FID,
    LOCATIONIDTO T_FID,
    TOTALAMOUNT T_MONEY_NULL,
    TOTALQTY T_QUANTITY_NULL,
    DOCINVOICEID T_STR20,
    DOCINVOICEDATE T_DATE_NULL,
    DOCFACTUREID T_STR20,
    DOCFACTUREDATE T_DATE_NULL,
    ISPACKAGE T_INT_VALUE,
    comment T_COMMENT,
    DOCIDSM T_FID,
    TIMEARRIVAL T_DATE_NULL,
    NAMERECEIVER T_STRING60_NULL,
    VOLUME T_QUANTITY_NULL,
    NULLDATE T_DATE_NULL,
    DOCINDEX T_DOC_INDEX)
AS
declare variable v_DocNum t_str20;
declare variable v_num_tn t_num_tn;
declare variable v_time_arival t_add_param;
declare variable v_namereceiver t_add_param;
declare variable v_date t_int_value;
declare variable v_date2 t_int_value;
declare variable v_doinv smallint;
declare variable v_dockind integer;
begin
  ispackage = 0;
  nulldate = '1900-01-01';
  v_date = gen_id(axapta_date_gen,0);
  v_date2 = datetoint(current_timestamp);
  if (v_date2 > v_date) then begin
    if (exists(select 1 from OVS_STAGE where id = :stage_id and axapta_time is null))
      then v_doinv = 1;
      else v_doinv = 0;
    if (v_doinv = 0)
      then if (exists(select 1 from OVS_STAGE
                        where id = :stage_id and
                              ((extract(hour from current_timestamp) * 100 + extract(minute from current_timestamp)) -
                               (extract(hour from axapta_time) * 100 + extract(minute from axapta_time))) >= 0))
             then v_doinv = 1;
    if (v_doinv = 1) then begin
      docinvoiceid = '';
      docnum = '';
      docindex = '';
      namereceiver = v_namereceiver;
      operationtypeid = coalesce(operationtypeid, 0);
      storeid = coalesce(storeid, 0);
      contragentid = coalesce(contragentid, 0);
      locationidfrom = coalesce(locationidfrom, 0);
      locationidto = coalesce(locationidto, 0);
      totalamount = coalesce(totalamount, 0);
      totalqty = coalesce(totalqty, 0);
      docfactureid = coalesce(docfactureid, '');
      comment = coalesce(comment, '');
      docidsm = coalesce(docidsm, 0);
      timearrival = coalesce(timearrival, '1900-01-01');
      docinvoicedate = coalesce(docinvoicedate, '1900-01-01');
      namereceiver = coalesce(namereceiver, '');
      docfacturedate = coalesce(docfacturedate, '1900-01-01');
      volume = 0;
      docflowid = 46;
      docheaderid = gen_id(dochead_gen, 1);
      docdate = current_timestamp;
      suspend;
    end
  end
  v_DocNum = '';
  -- comment must be cutted low to 250 characters, num_tn from 256--->20
  for select dh.id_dochead, dh.operation, coalesce(ova.docflow_id, 43), dh.dochead_filialindex, dp.axapta_num, dh.doc_date,
             dh.client_index, dh.client2_index, dh.totalrub, sum(ds.quantity), left(coalesce(dh.ext_docindex,''), 20),
             coalesce(dh.ext_doc_date, '1900-01-01'), dp.num_tn, coalesce(dp.date_tn, '1900-01-01'),
             dh.comment, dh.id_dochead, dh.add_param9, dh.add_param5, dsa.num_value, dh.dockind, dh.docindex
    from DOCHEAD_OVS dov
    inner join DOCHEAD dh on dh.id_dochead = dov.dochead and dh.accept = 'T'
    left join OVS_AXAPTA ova on ova.ovs_id = dov.ovs_kind and ova.doctype_id = dh.doctype and ova.operation_id = dh.operation
    left join AXAPTA_DOCFLOW adf on adf.is_import = 0 and adf.docflowid = ova.docflow_id
    left join DOCHEAD_PARAMS dp on dp.dochead = dh.id_dochead
    left join DOCSPEC ds on ds.id_dochead = dh.id_dochead
    left join DOCHEAD_SMREF_ADD dsa on dsa.kind = 25 and dsa.id_dochead = dh.id_dochead
    where dov.ovs_kind = :stage_id and dov.post_status = 20 and
          ((ova.ovs_id is not null and adf.docflowid is not null) or (dh.doctype in (1000,1001)))
    group by dh.id_dochead, dh.operation, ova.docflow_id, dh.dochead_filialindex, dp.axapta_num, dh.doc_date,
             dh.client_index, dh.client2_index, dh.totalrub, dh.ext_docindex, dp.num_tn,
             dh.comment, dh.id_dochead, dh.add_param9, dh.add_param5, dsa.num_value, dh.ext_doc_date, dp.date_tn, dh.dockind, dh.docindex
    order by dp.axapta_num, ova.docflow_id
  into :DocHeaderId, :OperationTypeId, :DocFlowId, :StoreId, :DocNum, :DocDate,
       :ContragentId, :LocationIdFrom, :TotalAmount, :TotalQty, :DocInvoiceId,
       :DocInvoiceDate, :v_num_tn, :DocFactureDate,
       :Comment, :DocIdSM, :v_time_arival, :v_namereceiver, :Volume, :v_dockind, :docindex
  do begin
    if (not exists(select 1
                     from DOCHEAD dh
                     inner join OPERATIONS oper on oper.id_operation = dh.operation and oper.is_package = 1
                     inner join DOCSPEC ds on ds.id_dochead = dh.id_dochead
                     inner join CARDSCLA cc on cc.articul = ds.articul
                     inner join CARDTYPES cts on cts.id_cardtype = cc.cardtype and cts.cardkind <> 2
                     where dh.id_dochead = :DocHeaderId)) then begin
      if (DocFlowId not in (20,23,27,31,33,35,36,38,40,41,42))
        then docindex = '';

      if (DocFlowId in (45,20)) then begin
        locationidto = locationidfrom;
        locationidfrom = 0;
      end else locationidto = null;
      if (trim(coalesce(v_num_tn, '')) = '')
        then v_num_tn = null;
        else v_num_tn = trim(v_num_tn);
      if (v_num_tn is not null) then begin
        if (char_length(v_num_tn) > 20) then v_num_tn = left(v_num_tn, 20);
      end
      DocFactureId = v_num_tn;
      if (trim(coalesce(docnum, '')) = '')
        then docnum = null;
        else docnum = trim(docnum);
      if (trim(coalesce(comment, '')) = '')
        then comment = null;
        else comment = trim(comment);
      if (comment is not null) then begin
        if (char_length(Comment) > 250) then comment = left(comment, 250);
      end
      if (trim(coalesce(v_time_arival, '')) = '')
        then v_time_arival = null;
        else v_time_arival = trim(v_time_arival);
      if (v_time_arival is not null) then begin
        TimeArrival = strtodate(v_time_arival);
        if (TimeArrival = strtodate('fdfdf')) then TimeArrival = null;
      end
      if (trim(coalesce(v_namereceiver, '')) = '')
        then v_namereceiver = null;
        else v_namereceiver = trim(v_namereceiver);
      if (v_namereceiver is not null) then begin
        if (char_length(v_namereceiver) > 60) then v_namereceiver = left(v_namereceiver, 60);
      end
      NameReceiver = v_namereceiver;
      operationtypeid = coalesce(operationtypeid, 0);
      docflowid = coalesce(docflowid, 0);
      storeid = coalesce(storeid, 0);
      contragentid = coalesce(contragentid, 0);
      locationidfrom = coalesce(locationidfrom, 0);
      locationidto = coalesce(locationidto, 0);
      totalamount = coalesce(totalamount, 0);
      totalqty = coalesce(totalqty, 0);
      docfactureid = coalesce(docfactureid, '');
      comment = coalesce(comment, '');
      docidsm = coalesce(docidsm, 0);
      timearrival = coalesce(timearrival, '1900-01-01');
      namereceiver = coalesce(namereceiver, '');
      volume = coalesce(volume, 0);
      -- 1
      if (DocFlowId = 20 and (docnum is not null) and (docdate is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        suspend;
      end
      -- 2
      if (DocFlowId = 23 and (DocInvoiceId is not null) and (docdate is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        if (v_dockind = 6) then
          select dp.axapta_num
            from DOCHEAD_LINK dl
            inner join PARTSPEC ps on ps.dochead = dl.dochead
            inner join DOCHEAD_PARAMS dp on dp.dochead = ps.indochead
            where dl.basedochead = :DocHeaderId and dp.axapta_num is not null
            rows 1
          into :docnum;
        else
          select dp.axapta_num
            from PARTSPEC ps
            inner join DOCHEAD_PARAMS dp on dp.dochead = ps.indochead
            where ps.dochead = :DocHeaderId and dp.axapta_num is not null
            rows 1
          into :docnum;
        docnum = coalesce(docnum, '');
        suspend;
      end
      -- 3
      if (DocFlowId = 27 and (DocDate is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        suspend;
      end
      -- 4
      if (DocFlowId = 31 and (DocInvoiceId is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        if (v_dockind = 6) then
          select dp.axapta_num
            from DOCHEAD_LINK dl
            inner join RETSPEC ps on dl.dochead = ps.dochead
            inner join DOCHEAD_PARAMS dp on dp.dochead = ps.outdochead
            where dl.basedochead = :DocHeaderId and dp.axapta_num is not null
            rows 1
          into :docnum;
        else
          select dp.axapta_num
            from RETSPEC ps
            inner join DOCHEAD_PARAMS dp on dp.dochead = ps.outdochead
            where ps.dochead = :DocHeaderId and dp.axapta_num is not null
            rows 1
          into :docnum;
        docnum = coalesce(docnum, '');
        suspend;
      end
      -- 5
      if (DocFlowId = 33 and (docnum is not null)) then
        if (v_DocNum <> DocNum) then
          if (not exists(select 1
                           from DOCHEAD_PARAMS dp
                           left join DOCHEAD dh on dp.dochead = dh.id_dochead
                           where dp.axapta_num = :docnum and dh.accept = 'F')) then begin
            select coalesce(sum(dh.totalrub), 0), coalesce(sum(ds.quantity), 0)
              from DOCHEAD_PARAMS dp2
              inner join DOCHEAD_OVS dov on dov.dochead = dp2.dochead and dov.post_status = 20 and dov.ovs_kind = :stage_id
              inner join DOCHEAD dh on dh.id_dochead = dp2.dochead
              inner join OVS_AXAPTA ova on ova.ovs_id = :stage_id and ova.doctype_id = dh.doctype and ova.operation_id = dh.operation and ova.docflow_id = 33
              inner join DOCSPEC ds on dh.id_dochead = ds.id_dochead
              where dp2.axapta_num = :docnum
            into :TotalAmount, :TotalQty;
            docnum = coalesce(docnum,'');
            docdate = coalesce(docdate,'1900-01-01');
            docinvoiceid = coalesce(docinvoiceid,'');
            v_DocNum = DocNum;
            suspend;
          end
      -- 6
      if (DocFlowId in (35,36,38,40,41,42,43,45)) then begin
        if (docflowid = 36) then begin
          locationidto = locationidfrom;
          locationidfrom = contragentid;
          contragentid = 0;
        end
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        suspend;
      end
    end
  end
end^

create or alter procedure AXAPTA_CUSTVENDTABLE (
    CONTRAGENTID T_FID,
    INN T_INN,
    CONTRAGENTNUM T_STR20,
    NAME T_STR_VALUE,
    CITY T_INT_VALUE,
    ADDRES T_STR_VALUE,
    KPP T_KPP,
    SEGMENTID T_FID,
    EDIACTIVE T_INT_VALUE,
    RETURNGROUPID T_FID,
    ADDRESPOSTAL T_STR_VALUE,
    NAMEALIAS T_FULL_NAME_NULL,
    RETURNALLOW T_INT_VALUE,
    REVERSEALLOW T_INT_VALUE,
    TAXCODE T_INT_VALUE)
returns (
    ERR T_STRING100_NULL)
AS
declare variable v_id_clients t_fid;
declare variable err_ T_STR4096;
begin
  EDIActive = coalesce(EDIActive, 0);
  taxcode = coalesce(taxcode, 0);
  if (taxcode = 0) then taxcode = -1;
  if (ContragentId is null) then err_ = '  ContragentId';
  if (trim(coalesce(namealias, '')) = '')
    then if (err_ is null)
           then err_ = '  NAMEALIAS';
           else err_ = err_ || ',   NAMEALIAS';
  if (SegmentId is null)
    then if (err_ is null)
           then err_ = '  SegmentId';
           else err_ = err_ || ',   SegmentId';
  if (city = 0) then city = null;
  if (city <> 0 and
      not exists(select 1 from CITY where id_city = :city))
    then if (err_ is null)
           then err_ = '   SM (City)';
           else err_ = err_ || ',    SM (City)';
  if (segmentid is not null and
      not exists(select 1 from CLASSIF where id_classif = :segmentid))
    then if (err_ is null)
           then err_ = ' segmentid';
           else err_ = err_ || ',  segmentid';
  if (coalesce(returngroupid, 0) <> 0 and
      not exists(select 1 from OPRETGROUP_HEAD where id = :returngroupid))
    then if (err_ is null)
           then err_ = ' returngroupid';
           else err_ = err || ',  returngroupid';
  if (taxcode > 0 and
      not exists(select 1 from TAXHEAD where id_taxhead = :taxcode))
    then if (err_ is null)
           then err_ = ' TaxCode';
           else err_ = err || ',  TaxCode';

  if (char_length(err_) >= 100)
    then err = left(err_, 95) || '...';
    else err = err_;
  if (err is null) then begin
    if (coalesce(returnallow, 0) > 0)
      then returnallow = 1;
      else returnallow = 0;
    if (coalesce(reverseallow, 0) > 0)
      then reverseallow = 1;
      else reverseallow = 0;

    update or insert into CLIENTS(client_type, id_clients, inn_clients, ident_clients,
                                  name_clients, city_clients, addres_clients, kpp,
                                  classif, is_juridical, opretgroup,
                                  f_address, legal_name, def_taxhead)
      values(0, :contragentid, :inn, :contragentnum,
             :namealias, :city, :addres, :kpp,
             :segmentid, 'T', iif(:returngroupid = 0, null, :returngroupid),
             :addrespostal, :name, :taxcode)
    returning id_clients into :v_id_clients;

    update or insert into CLIENT_SMREF_ADD(id_clients, kind, id, num_value)
      values(:v_id_clients, 64, -1, iif(:EDIActive > 0, 1, 0));
    update or insert into CLIENT_SMREF_ADD(id_clients, kind, id, num_value)
      values(:v_id_clients, 95, -1, :returnallow);
    update or insert into CLIENT_SMREF_ADD(id_clients, kind, id, num_value)
      values(:v_id_clients, 96, -1, :reverseallow);
  end
  suspend;
end^

create or alter procedure AXAPTA_EXPDOCHEADER (
    DAXRECID T_DAXRECID,
    DOCHEADKIND T_FID,
    DOCHEADTYPE T_FID,
    OPERATIONTYPEID T_FID,
    DOCFLOWID T_INT_VALUE,
    IMPOPERATIONTYPEID T_INT_VALUE,
    STOREID T_FID,
    DOCNUM T_STR20,
    DOCDATE T_DATE_NULL,
    CONTRAGENTID T_FID,
    LOCATIONIDFROM T_FID,
    LOCATIONIDTO T_FID,
    TOTALAMOUNT T_MONEY_NULL,
    TOTALQTY T_QUANTITY_NULL,
    comment T_COMMENT,
    DOCINVOICEID T_STR20,
    AGREEMENTID T_FID,
    ISCORRDOC T_INT_VALUE,
    STAGE_ID T_FID,
    CONTR T_FID,
    DOCFACTUREID T_STR20,
    DOCINVOICEDATE T_DATE_NULL,
    DOCFACTUREDATE T_DATE_NULL,
    SOURCEDOCIDSM T_FID)
returns (
    ERR T_STRING100_NULL,
    DOCHEAD_ID T_FID)
AS
declare variable err_ t_str4096;
declare variable out_dochead integer;
declare variable v_docindex t_doc_index;
declare variable v_user integer;
declare variable v_basedh integer;
declare variable nulldate t_date_null;
begin
  --  :
  totalqty = totalqty;
  impoperationtypeid = impoperationtypeid;

  nulldate = '1900-01-02'; --      
  if (docinvoicedate <= nulldate) then docinvoicedate = null;
  if (docfacturedate <= nulldate) then docfacturedate = null;
  dochead_id = -1;
  select id from CUR_USER into :v_user;
  IsCorrDoc = coalesce(IsCorrDoc, 0);
  if (not(coalesce(DocFlowId, -1) in (19,21,22,24,25,26,28,29,30,32,34,37,39,44,49))) then begin
    err = '   DocFlowId';
    suspend;
    exit;
  end
  select dockind from AXAPTA_DOCFLOW where docflowid = :docflowid into :docheadkind;
  if (docflowid = 49) then DocHeadKind = -10;
  if (DocHeadKind is null and (DocFlowId <> 49))
    then err_ = '  DocHeadKind';
  if (DocHeadType is null)
    then if (err_ is null)
           then err_ = '  DocHeadType';
           else err_ = err_ || '/DocHeadType';
  if (trim(coalesce(docnum, '')) = '')
    then if (err_ is null)
           then err_ = '  DOCNUM';
           else err_ = err_ || '/DOCNUM';
  if (OperationTypeId is null)
    then if (err_ is null)
           then err_ = '  OperationTypeId';
           else err_ = err_ || '/OperationTypeId';
  if (StoreId is null and DocFlowId <> 49)
    then if (err_ is null)
           then err_ = '  StoreId';
           else err_ = err_ || '/StoreId';
  if (DocDate is null and DocFlowId <> 49)
    then if (err_ is null)
           then err_ = '  DocDate';
           else err_ = err_ || '/DocDate';
  if (not ((coalesce(docflowid, -1) in (32,34,37,39,49)))) then begin
    if (coalesce(ContragentId, 0) = 0)
      then if (err_ is null)
             then err_ = '  ContragentId';
             else err_ = err_ || '/ContragentId';
  end
  if (coalesce(DocHeadKind, -1) = 1 and (coalesce(docflowid, -1) <> 21) or
      coalesce(docflowid, -1) in (34,37,30,28)) then begin
    if (coalesce(LocationIdFrom, 0) = 0)
      then if (err_ is null)
             then err_ = '  LocationIdFrom';
             else err_ = err_ || '/LocationIdFrom';
  end
  if (coalesce(DocHeadKind, -1) in (0,6) and not (coalesce(docflowid,-1) in (30,28)) or
      coalesce(docflowid,-1) in (32,39,21)) then begin
    if (coalesce(LocationIdTo, 0) = 0)
      then if (err_ is null)
             then err_ = '  LocationIdTo';
             else err_ = err_ || '/LocationIdTo';
  end
  if (TotalAmount is null and (DocFlowId <> 49))
    then if (err_ is null)
           then err_ = '  TotalAmount';
           else err_ = err_ || '/TotalAmount';
  if (DocHeadKind is not null) then
    if (docheadkind not in (0,1,6,-10)) then begin
      if (err_ is null)
        then err_ = '   DocHeadKind';
        else err_ = err_ || ',    DocHeadKind';
    end
  if (DocHeadType is not null) then
    if (not exists(select 1 from DOCTYPE where id_doctype = :DocHeadType)) then begin
      if (err_ is null)
        then err_ = '   DocHeadType';
        else err_ = err_ || ',    DocHeadType';
    end
  if (OperationTypeId is not null) then
    if (not exists(select 1 from OPERATIONS where id_operation = :OperationTypeId)) then begin
      if (err_ is null)
        then err_ = '   OperationTypeId';
        else err_ = err_ || ',    OperationTypeId';
    end
  if (StoreId is not null and DocFlowId <> 49) then
    if (not exists(select 1 from TH_CLASSIF where id_th_classif = :StoreId)) then begin
      if (err_ is null)
        then err_ = '   StoreId';
        else err_ = err_ || ',    StoreId';
    end
  if (not (coalesce(docflowid, -1) in (32,34,37,39,49)) and
      not (coalesce(ContragentId, 0) = 0)) then begin
    if (not exists(select 1 from CLIENTS where id_clients = :ContragentId))
      then if (err_ is null)
             then err_ = '  ContragentId';
             else err_ = err_ || ',   ContragentId';
  end
  if ((coalesce(DocHeadKind, -1) = 1 and coalesce(docflowid, -1) <> 21 or coalesce(docflowid, -1) in (28,34,37,30)) and
      not(coalesce(LocationIdFrom, 0) = 0)) then begin
    if (not exists(select 1 from CLIENTS where id_clients = :LocationIdFrom and classif = :StoreId))
      then if (err_ is null)
             then err_ = '  LocationIdFrom';
             else err_ = err_ || ',   LocationIdFrom';
  end
  if ((coalesce(DocHeadKind, -1) in (0,6) or coalesce(docflowid, -1) in (21,32,39)) and
      not(coalesce(LocationIdTo, 0) = 0) and not (coalesce(docflowid, -1) in (28,30))) then begin
    if (not exists(select 1 from CLIENTS where id_clients = :LocationIdTo and classif = :StoreId))
      then if (err_ is null)
             then err_ = '  LocationIdTo';
             else err_ = err_ || ',   LocationIdTo';
  end
  if (not(coalesce(AgreementId, 0) = 0) and DocFlowId <> 49) then
    if (not exists(select 1 from CLIENT_AGREEMENTS where id = :AgreementId))
      then if (err_ is null)
             then err_ = '  AgreementId';
             else err_ = err_ || ',   AgreementId';

  if (err_ is null and (DocFlowId <> 49)) then
    if (not exists(select 1 from OVS_AXAPTA
                     where ovs_id = :stage_id and docflow_id = :docflowid and
                           doctype_id = :docheadtype and operation_id = :OperationTypeId))
      then err_ = '             ';

  if (char_length(err_) >= 100)
    then err = left(ERR_, 95) || '...';
    else err = err_;

  if (err is null) then begin
    if (docflowid = 49) then begin
      select dp.dochead
        from DOCHEAD_PARAMS dp
        inner join DOCHEAD dh on dh.id_dochead = dp.dochead
        where dp.axapta_num = :docnum and dh.doctype = :docheadtype and dh.operation = :operationtypeid
        rows 1
      into :out_dochead;
      if (out_dochead is null) then
        err = '  ';
      else begin
        docinvoiceid = iif(trim(coalesce(docinvoiceid, '')) = '', null, docinvoiceid);
        DocFactureId = iif(trim(coalesce(DocFactureId, '')) = '', null, DocFactureId);
        update DOCHEAD dh set dh.ext_docindex = :docinvoiceid, dh.ext_doc_date = :DocInvoiceDate
          where dh.id_dochead = :out_dochead;
        update DOCHEAD_PARAMS dp set dp.num_tn = :DocFactureId, dp.date_tn = :docfacturedate
          where dp.dochead = :out_dochead;
      end
      suspend;
      exit;
    end
    if (docflowid = 21) then locationidfrom = locationidto;
    if (docflowid = 28) then locationidto = locationidfrom;
    if (docflowid in (32,39)) then begin
      ContragentId = contr;
      ContragentId = coalesce(ContragentId, 0);
      if (ContragentId = 0) then ContragentId = -2;
      if (ContragentId <> -2) then
        if (not exists(select 1 from CLIENTS where id_clients = :contragentid)) then begin
          err = '  ContragentId';
          suspend;
          exit;
        end
    end

    if (docflowid in (34,37) or ContragentId = -2 and docflowid in (32,39))
      then select client_id
            from OVS_AXAPTA
            where ovs_id = :stage_id and docflow_id = :docflowid and
                  doctype_id = :docheadtype and operation_id = :operationtypeid
          into :contragentid;
    if (DocFlowId not in (49, 21, 22, 24, 25, 28, 29) and
        exists(select 1
                 from DOCHEAD_PARAMS dp
                 inner join DOCHEAD dh on dh.id_dochead = dp.dochead and dh.accept = 'T' and
                                          dh.doctype = :docheadtype and dh.operation = :operationtypeid and
                                          (:docflowid not in (32,39) or dh.client_index = :contragentid) 
               where dp.axapta_num = :docnum)) then begin
      err = '  ';
      suspend;
      exit;
    end
    if ((DocFlowId in (21, 22, 24, 25, 28, 29))) then begin
      if (exists(select 1
                   from DOCHEAD_PARAMS dp
                   inner join DOCHEAD dh on dh.id_dochead = dp.dochead
                   where coalesce(dp.axapta_daxrecid, -1) = :daxrecid and dh.accept = 'T')) then begin
        err = '  ';
        suspend;
        exit;
      end
      if (exists(select 1 from DOCHEAD_PARAMS where coalesce(axapta_daxrecid, -1) = :daxrecid)) then begin
        select dp.dochead, dh.docindex
          from DOCHEAD_PARAMS dp
          inner join DOCHEAD dh on dh.id_dochead = dp.dochead
          where coalesce(dp.axapta_daxrecid, -1) = :daxrecid
          rows 1
        into :out_dochead, :v_docindex;
        delete from DOCSPEC_OVS where dochead = :out_dochead;
        delete from DOCSPEC where id_dochead = :out_dochead;
        delete from DOCHEAD_AGREEMENT_LINK where dochead = :out_dochead;
      end else begin
        out_dochead = gen_id(dochead_gen, 1);
        select docindex from GET_NEW_DOCINDEX(1, :DocHeadType, :DocDate) into :v_docindex;
      end
    end else
    if (exists(select 1
          from DOCHEAD_PARAMS dp
          inner join DOCHEAD dh on dh.id_dochead = dp.dochead
          where dp.axapta_num = :docnum and dh.doctype = :docheadtype and dh.operation = :operationtypeid and
                (dh.client_index = coalesce(:contr, -1) or (:docflowid not in (32,39))))) then begin
      select dp.dochead, dh.docindex
        from DOCHEAD_PARAMS dp
        inner join DOCHEAD dh on dh.id_dochead = dp.dochead
        where dp.axapta_num = :docnum and dh.doctype = :docheadtype and dh.operation = :operationtypeid
        rows 1
      into :out_dochead, :v_docindex;
      delete from DOCSPEC_OVS dov where dov.dochead = :out_dochead;
      delete from DOCSPEC ds where ds.id_dochead = :out_dochead;
      delete from DOCHEAD_AGREEMENT_LINK where dochead = :out_dochead;
    end else begin
      out_dochead = gen_id(dochead_gen, 1);
      select docindex from GET_NEW_DOCINDEX(1, :DocHeadType, :DocDate) into :v_docindex;
    end
    dochead_id = out_dochead;     
    if (docflowid = 30) then locationidto = locationidfrom;
    update or insert into DOCHEAD(id_dochead, shopindex, dochead_filialindex, doctype, docindex, dockind,
                                  doc_date, client_index, client2_index, operation, manager, comment)
      values(:out_dochead, 1, :storeid, :DocHeadType, :v_docindex, :DocHeadKind,
             :DocDate, :ContragentId, iif(:DocHeadKind = 1, :locationidfrom, :locationidto), :OperationTypeId, :v_user, :comment);
    if (docflowid = 19) then begin
      docinvoiceid = iif(trim(coalesce(docinvoiceid, '')) = '', null, docinvoiceid);
      DocFactureId = iif(trim(coalesce(DocFactureId, '')) = '', null, DocFactureId);
      update DOCHEAD set ext_docindex = :docinvoiceid, ext_doc_date = :DocInvoiceDate where id_dochead = :out_dochead;
      update DOCHEAD_PARAMS set num_tn = :DocFactureId, date_tn = :docfacturedate where dochead = :out_dochead;
    end
    if (not(coalesce(AgreementId, 0) = 0))
      then insert into DOCHEAD_AGREEMENT_LINK(dochead, agreement) values(:out_dochead, :AgreementId);
    update DOCHEAD_PARAMS
      set axapta_num = :docnum, axapta_daxrecid = iif((:DocFlowId in (21, 22, 24, 25, 28 ,29)), :daxrecid, null)
    where dochead = :out_dochead;

    if (SourceDocIdSM > 0 and DocFlowId in (21, 22, 24, 25, 28 ,29))
      then update DOCHEAD_PARAMS
             set axapta_num = :docnum
           where dochead = :SourceDocIdSM and coalesce(axapta_num, '') = '';

    update or insert into DOCHEAD_OVS(dochead, ovs_kind, bool_p, post_status) values(:out_dochead, :stage_id, 'F', 5);

    if (trim(coalesce(docinvoiceid, '')) <> '')
      then select dochead from DOCHEAD_PARAMS where axapta_num = :docinvoiceid rows 1 into :v_basedh;
    if (v_basedh is not null)
      then update or insert into DOCHEAD_LINK(dochead, basedochead) values(:out_dochead, :v_basedh);
    delete from DOCSPEC_OVS where dochead = :out_dochead;
  end
  suspend;
end^

set term ; ^




-- SM-3582    

set term ^ ;

create or alter procedure EGAIS_XML_TRANSFER1 (
    ID     T_DOC,
    SENDER T_CLIENT_INDEX)
returns (
    XMLSTR T_LONG_STR)
AS
declare variable QUANTITY double precision;
declare variable RFU2     T_STRING50;
declare variable ALC_CODE T_ALC_CODE;
declare variable POS_NUM  integer;
declare variable IDENT    integer;
declare variable GUID     T_GUID_DASHED;
declare variable HAVE_NEW_MARK integer;
begin

  --   XML-    
  xmlstr = '<?xml version="1.0" encoding="UTF-8"?>'; suspend;
  xmlstr = '<ns:Documents Version="1.0"'; suspend;
  xmlstr = 'xmlns:ns="http://fsrar.ru/WEGAIS/WB_DOC_SINGLE_01" '; suspend;
  xmlstr = 'xmlns:xs="http://www.w3.org/2001/XMLSchema" '; suspend;
  xmlstr = 'xmlns:c="http://fsrar.ru/WEGAIS/Common" '; suspend;
  xmlstr = 'xmlns:pref="http://fsrar.ru/WEGAIS/ProductRef_v2" '; suspend;
  xmlstr = 'xmlns:tts="http://fsrar.ru/WEGAIS/TransferToShop"> '; suspend;
  -- 
  xmlstr = '<ns:Owner>'; suspend;
  select '<ns:FSRAR_ID>' || cp.paramvalue || '</ns:FSRAR_ID>'
    from CLIENTPARAMS cp where cp.paramtype = 14 and cp.client_id = :SENDER
  into xmlstr; suspend;
  xmlstr = '</ns:Owner>'; suspend;

  select IDENTITY
    from EGAIS_TRANSFER
   where ID = :ID
    into :GUID;

  --  
  xmlstr = '<ns:Document>'; suspend;
  xmlstr = '<ns:TransferToShop>'; suspend;
  xmlstr = '<tts:Identity>' || GUID ||'</tts:Identity>'; suspend;
  xmlstr = '<tts:Header>'; suspend;
  xmlstr = '<tts:TransferNumber>' || xmlcheckstr(ID) ||'</tts:TransferNumber>'; suspend;
  xmlstr = '<tts:TransferDate>' || datetostr('yyyy-mm-dd','NOW') || '</tts:TransferDate>'; suspend;
  xmlstr = '</tts:Header>'; suspend;

  -- 
  xmlstr = '<tts:Content>'; suspend;
  IDENT = 0;
  for
    select QUANTITY, RFU2, ALC_CODE, POS_NUM
      from EGAIS_TRANSFER_SPEC_EXT
     where DOC_ID = :ID
      into :QUANTITY, :RFU2, :ALC_CODE, :POS_NUM
  do
  begin
    --   2    ,   2    XML.
    --     ,      .
    --    ( 4  2018 )     .
    HAVE_NEW_MARK = iif(exists(select 1 from EGAIS_REMAINS_MARKS where RFU2 = :RFU2 and MARK_TYPE = 2 and UTM = :SENDER), 1, 0);
    if (HAVE_NEW_MARK = 0 and abs(QUANTITY) > 1e-9) then
    begin
      IDENT = IDENT + 1;
      xmlstr = '<tts:Position>'; suspend;
      xmlstr = '<tts:Identity>' || IDENT || '</tts:Identity>'; suspend;
      xmlstr = '<tts:ProductCode>'|| ALC_CODE ||'</tts:ProductCode>'; suspend;
      xmlstr = '<tts:Quantity>' || doubletrunc(QUANTITY, '0.0000') || '</tts:Quantity>'; suspend;
      xmlstr = '<tts:InformF2>'; suspend;
      xmlstr = '<pref:F2RegId>' || RFU2 || '</pref:F2RegId>'; suspend;
      xmlstr = '</tts:InformF2>'; suspend;
      xmlstr = '</tts:Position>'; suspend;
  
      update EGAIS_TRANSFER_SPEC_EXT
         set IDENTITY = :IDENT
       where POS_NUM = :POS_NUM
         and DOC_ID = :ID;
    end
  end
  xmlstr = '</tts:Content>'; suspend;
  xmlstr = '</ns:TransferToShop>'; suspend;
  xmlstr = '</ns:Document>'; suspend;
  xmlstr = '</ns:Documents>'; suspend;
end^




create or alter procedure EGAIS_XML_TRANSFER2 (
    ID     T_DOC,
    SENDER T_CLIENT_INDEX)
returns (
    XMLSTR T_LONG_STR)
AS
declare variable GUID     T_GUID_DASHED;
declare variable QUANTITY T_QUANTITY_NULL;
declare variable RFU2     T_STRING50;
declare variable ALC_CODE T_ALC_CODE;
declare variable IDENT    T_FID;
declare variable POS_NUM  T_FID;
begin

  --   XML-    
  xmlstr = '<?xml version="1.0" encoding="UTF-8"?>'; suspend;
  xmlstr = '<ns:Documents Version="1.0"'; suspend;
  xmlstr = 'xmlns:ns="http://fsrar.ru/WEGAIS/WB_DOC_SINGLE_01" '; suspend;
  xmlstr = 'xmlns:xs="http://www.w3.org/2001/XMLSchema" '; suspend;
  xmlstr = 'xmlns:c="http://fsrar.ru/WEGAIS/Common" '; suspend;
  xmlstr = 'xmlns:pref="http://fsrar.ru/WEGAIS/ProductRef_v2" '; suspend;
  xmlstr = 'xmlns:tts="http://fsrar.ru/WEGAIS/TransferFromShop"> '; suspend;

  -- 
  xmlstr = '<ns:Owner>'; suspend;
  select '<ns:FSRAR_ID>' || cp.paramvalue || '</ns:FSRAR_ID>'
    from CLIENTPARAMS cp where cp.paramtype = 14 and cp.client_id = :SENDER
  into xmlstr; suspend;
  xmlstr = '</ns:Owner>'; suspend;

  select IDENTITY
    from EGAIS_TRANSFER
   where ID = :ID
    into :GUID;

  --  
  xmlstr = '<ns:Document>'; suspend;
  xmlstr = '<ns:TransferFromShop>'; suspend;
  xmlstr = '<tts:Identity>' || GUID ||'</tts:Identity>'; suspend;
  xmlstr = '<tts:Header>'; suspend;
  xmlstr = '<tts:TransferNumber>' || xmlcheckstr(ID) ||'</tts:TransferNumber>'; suspend;
  xmlstr = '<tts:TransferDate>' || datetostr('yyyy-mm-dd','NOW') || '</tts:TransferDate>'; suspend;
  xmlstr = '</tts:Header>'; suspend;

  -- 
  xmlstr = '<tts:Content>'; suspend;
  IDENT = 0;
  for
    select rf.QUANTITY, rf.RFU2, ex.ALC_CODE, ex.POS_NUM
      from EGAIS_TRANSFER_SPEC_EXT ex
      join EGAIS_TRANSFER_SPEC_RFU rf on rf.DOC_ID = ex.DOC_ID
                                     and rf.POS_NUM = ex.POS_NUM
     where ex.DOC_ID = :ID
       and rf.QUANTITY > 1e-9
      into :QUANTITY, :RFU2, :ALC_CODE, :POS_NUM
  do
  begin
    IDENT = IDENT + 1;
    xmlstr = '<tts:Position>'; suspend;
    xmlstr = '<tts:Identity>' || IDENT || '</tts:Identity>'; suspend;
    xmlstr = '<tts:ProductCode>'|| ALC_CODE ||'</tts:ProductCode>'; suspend;
    xmlstr = '<tts:Quantity>' || doubletrunc(QUANTITY, '0.0000') || '</tts:Quantity>'; suspend;
    xmlstr = '<tts:InformF2>'; suspend;
    xmlstr = '<pref:F2RegId>' || RFU2 || '</pref:F2RegId>'; suspend;
    xmlstr = '</tts:InformF2>'; suspend;
    xmlstr = '</tts:Position>'; suspend;

    update EGAIS_TRANSFER_SPEC_EXT
       set IDENTITY = :IDENT
     where POS_NUM = :POS_NUM
       and DOC_ID = :ID;
  end
  xmlstr = '</tts:Content>'; suspend;
  xmlstr = '</ns:TransferFromShop>'; suspend;
  xmlstr = '</ns:Document>'; suspend;
  xmlstr = '</ns:Documents>'; suspend;
end^




create or alter procedure EGAIS_MAKE_TRANSFER_TTN_FETCH (
    TTN_ID T_ID,
    OWNER  T_ID)
returns (
    ARTICUL  T_ARTICUL_NULL,
    ALC_CODE T_ALC_CODE,
    QUANTITY T_QUANTITY_NULL,
    REG_A    T_STRING50,
    REG_B    T_STRING50,
    REMAINS  T_QUANTITY_NULL,
    FERROR   T_FID)
AS
declare variable CAP_COUNT integer;
declare variable MREMAINS double precision;
declare variable MQUANTITY double precision;
begin
  FERROR = 0;
  for --    ;   
    select coalesce(cl.ARTICUL, ''),
           ids.ALC_CODE, ide.CONFIRMED_QUANTITY, ide.REG_ID_A, ide.REG_ID_B2, coalesce(re.QUANTITY,0)
      from EGAIS_IN_DOCSPEC ids
      join EGAIS_IN_DOCSPEC_EXT ide on ide.ALC_CODE = ids.ALC_CODE
                                   and ide.DOCHEAD = ids.DOCHEAD
      left join EGAIS_CARDS_LINK cl on cl.ALC_CODE = ids.ALC_CODE
      left join EGAIS_REMAINS re on re.ALC_CODE = ids.ALC_CODE
                           and re.UTM = :OWNER
                           and re.REGISTER = 1
                           and re.REG_ID_A = ide.REG_ID_A
                           and re.REG_ID_B = ide.REG_ID_B2
     where ids.DOCHEAD = :TTN_ID
       into :ARTICUL, :ALC_CODE, :QUANTITY, :REG_A, :REG_B, :REMAINS
  do
  begin
  -- <      SM-3582.
    select count(*)                --       .
      from EGAIS_MARKS
     where DOC_EGAIS = :TTN_ID
       and DOC_KIND = 2
       and RFU2 = :REG_B
       and MARK_TYPE = 2
      into :MQUANTITY;

    select count(*)
      from EGAIS_REMAINS_MARKS
     where RFU2 = :REG_B
       and MARK_TYPE = 2
      into :MREMAINS;

    QUANTITY = QUANTITY - MQUANTITY;
    REMAINS = REMAINS - MREMAINS;
  -- >
    if (ARTICUL <> '') then
    begin
      select RESULT
        from EGAIS_CHECK_CARD_CAPACITY(:ARTICUL)
        into :CAP_COUNT;
  
      if (CAP_COUNT > 1) then
        FERROR = 1;
      end

    if (QUANTITY > REMAINS) then
      QUANTITY = REMAINS;

    if (QUANTITY > 0 or FERROR = 1) then
      suspend;

    if (FERROR = 1) then
      exit;
  end
end^




create or alter procedure EGAIS_MAKE_TRANSFER_TTN (
    TTN_ID T_ID,
    OWNER  T_ID)
returns (
    DOC_ID T_FID,
    MSG    T_STR_VALUE)
AS
declare variable ARTICUL  T_ARTICUL_NULL;
declare variable QUANTITY T_QUANTITY_NULL;
declare variable ALC_CODE T_ALC_CODE;
declare variable REG_A    T_STRING50;
declare variable REG_B    T_STRING50;
declare variable POS_NUM  T_FID;
declare variable FERROR    T_FID;
begin
  --        1   2     .
  Msg = null;
  DOC_ID = null;
  POS_NUM = 0;

  insert into TMP_LOG(KIND, LEVEL, TEXT) values (1, 3, '  1-2  .  '||:TTN_ID);

  for
    select ARTICUL, ALC_CODE, QUANTITY, REG_A, REG_B, FERROR
      from EGAIS_MAKE_TRANSFER_TTN_FETCH(:TTN_ID, :OWNER)
     order by FERROR desc  -- fetch      ,
                          --         ,
                          --         
      into  :ARTICUL, :ALC_CODE, :QUANTITY, :REG_A, :REG_B, :FERROR
  do
  if (QUANTITY > 1e-9) then
  begin
    if (FERROR = 1) then
    begin
      Msg = '   ,     <'||:ARTICUL||'>,      ';
      insert into TMP_LOG(KIND, LEVEL, TEXT) values (1, 1, :MSG);
      suspend;
      exit;
    end

    if (DOC_ID is null) then
      insert into EGAIS_TRANSFER (OWNER, KIND, DOC_KIND, DOC_ID, DOC_DATE, EGAIS_STATE)
           values (:OWNER, 1, 1, :TTN_ID, 'NOW', 1)
        returning (ID)
             into :DOC_ID;

    if (not exists(select 1
                     from EGAIS_TRANSFER_SPEC
                    where DOC_ID = :DOC_ID
                      and ARTICUL = :ARTICUL)) then
      insert into EGAIS_TRANSFER_SPEC (DOC_ID, ARTICUL, QUANTITY)
           values (:DOC_ID, :ARTICUL, :QUANTITY);
    else
      update EGAIS_TRANSFER_SPEC
         set QUANTITY = QUANTITY + :QUANTITY
       where DOC_ID = :DOC_ID
         and ARTICUL = :ARTICUL;


    POS_NUM = POS_NUM + 1;
    insert into EGAIS_TRANSFER_SPEC_EXT (DOC_ID, POS_NUM, ARTICUL, ALC_CODE, RFU1, RFU2, QUANTITY)
         values (:DOC_ID, coalesce(:POS_NUM,0), :ARTICUL, :ALC_CODE, :REG_A, :REG_B, :QUANTITY);
  end

  if (DOC_ID is null) then
  begin
    Msg = '          2';
    insert into TMP_LOG(KIND, LEVEL, TEXT) values (1, 1, :MSG);
  end

  suspend;
end^




create or alter procedure OVS3_CYCLE_S_DOC
returns (
    ID T_FID,
    XML_KIND T_STR30_NULL,
    TAG_KIND T_INT_VALUE,
    TAG_NAME T_STR30_NULL,
    V_PAR1 T_STR_VALUE,
    V_PAR2 T_STR_VALUE,
    V_PAR3 T_STR_VALUE,
    V_PAR4 T_STR_VALUE,
    V_PAR5 T_STR_VALUE,
    V_PAR6 T_STR_VALUE,
    V_PAR7 T_STR_VALUE,
    V_PAR8 T_STR_VALUE,
    V_PAR9 T_STR_VALUE,
    V_PAR10 T_STR_VALUE,
    V_PAR11 T_STR_VALUE,
    V_PAR12 T_STR_VALUE,
    V_PAR13 T_STR_VALUE,
    V_PAR14 T_STR_VALUE,
    V_PAR15 T_STR_VALUE)
AS
declare variable v_dt integer;
declare variable o_id integer;
declare variable v_id integer;
declare variable v_date date;
declare variable v_dbl double precision;
declare variable v_str varchar(512);
declare variable x_dockind integer;
declare variable x_doc_date date;
declare variable x_client_index integer;
declare variable x_client2_index integer;
declare variable x_operation integer;
declare variable x_docindex t_doc_index;
declare variable x_ext_docindex t_ext_doc_index;
declare variable x_ext_doc_date date;
declare variable x_i_param1 integer;
declare variable h_totalrub double precision;
declare variable s_pos_number integer;
declare variable s_articul t_articul_null;
declare variable s_quantity double precision;
declare variable s_pricerub double precision;
declare variable s_nds double precision;
declare variable s_custom t_custom;
declare variable s_country integer;
declare variable c_country integer;
declare variable s_taxhead integer;
declare variable h_nds1 double precision;
declare variable h_nds7 double precision;
begin
  --    
  --       (   )
  -- id   , xml_kind  
  -- tag_kind - 0 , 1   (        xml-)

  --    'v_'   xml-    tag_name
  --      : < >=< >
  -- ,  SMID=10666587    xml-  SMID="10666587"
  --    :  GTD=    xml-  GTD=""
  --      =           

  o_id = -1;
  for select x.id, upper(x.xml_kind), x.dockind, x.doc_date, x.client_index, x.client2_index,
             x.operation, x.docindex, x.ext_docindex, x.ext_doc_date, x.i_param1, h.totalrub,
             s.pos_number, s.articul, s.quantity, s.pricerub, s.nds, s.custom, s.country, s.taxhead
    from OVS_OUT_DOC x
    left join DOCHEAD h on h.id_dochead = x.id
    left join DOCSPEC s on s.id_dochead = h.id_dochead
    where x.post_status = 20 and x.xml_kind > ''
    order by 2, x.doc_date, x.id, s.pos_number
    into :id, :xml_kind, :x_dockind, :x_doc_date, :x_client_index, :x_client2_index,
         :x_operation, :x_docindex, :x_ext_docindex, :x_ext_doc_date, :x_i_param1, :h_totalrub,
         :s_pos_number, :s_articul, :s_quantity, :s_pricerub, :s_nds, :s_custom, :s_country, :s_taxhead
  do begin
    if (id <> o_id) then begin
      v_par1 = ''; v_par2 = ''; v_par3 = ''; v_par4 = ''; v_par5 = ''; v_par6 = ''; v_par7 = ''; v_par8 = '';
      v_par9 = ''; v_par10 = ''; v_par11 = ''; v_par12 = ''; v_par13 = ''; v_par14 = ''; v_par15 = '';
      --      
      tag_kind = 0; tag_name = 'HEAD'; h_nds1 = 0; h_nds7 = 0;
      if (xml_kind = 'SMPRIHODOUT' or xml_kind = 'SMPRIHOD' or xml_kind = 'SMVOZVRAT') then begin
        select sum(iif(taxhead = 1, nds, 0)), sum(iif(taxhead = 7, nds, 0))
          from DOCSPEC where id_dochead = :id
        into :h_nds1, :h_nds7;
      end

      if (xml_kind = 'SMPRIHODOUT') then begin --         (    SAP)
        v_id = x_i_param1;
        v_str = ''; --     
        select ext_docindex, doctype from DOCHEAD where id_dochead = :v_id into :v_str, :v_dt;
        if (v_str is null) then v_str = '';
        -- 1511 - , ..         
        if (v_dt = 1511) then v_id = -1;
        v_par1 = 'ID=' || v_str; --    
        v_par2 = 'SMID=' || id;  --   
        v_par3 = 'SMINDEX=' || x_docindex;  --   
        v_par4 = 'EXTID=' || x_ext_docindex; --     
        v_par5 = 'SCHDATE=' || iif(x_ext_doc_date is null, '', datetostr('YYYYMMDD', x_ext_doc_date)); --    
        v_par6 = 'SCHMOV=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par7 = 'SAPSTORE=' || v_str; -- - 
        v_str = ''; --     ()
        select add_param3_clients from CLIENTS where id_clients = :x_client_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par8 = 'SENDERID=' || v_str; -- - 
        v_par9 = 'DOCPRICE=' || numtostr('%.2f', h_totalrub); --   
        v_par10 = 'NDS10=' || numtostr('%.2f', h_nds1); --  10  
        v_par11 = 'NDS18=' || numtostr('%.2f', h_nds7); --  18  
        v_par12 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMPRIHOD') then begin --   (   S-Market)
        v_id = -1;
        v_par1 = 'SMID=' || id;  --   
        v_par2 = 'SMINDEX=' || x_docindex;  --   
        v_par3 = 'EXTID=' || x_ext_docindex; --     
        v_par4 = 'SCHDATE=' || iif(x_ext_doc_date is null, '', datetostr('YYYYMMDD', x_ext_doc_date)); --    
        v_par5 = 'SCHMOV=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par6 = 'SAPSTORE=' || v_str; -- - 
        v_str = ''; --     ()
        select add_param3_clients from CLIENTS where id_clients = :x_client_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par7 = 'SENDERID=' || v_str; -- - 
        v_par8 = 'DOCPRICE=' || numtostr('%.2f', h_totalrub); --   
        v_par9 = 'NDS10=' || numtostr('%.2f', h_nds1); --  10  
        v_par10 = 'NDS18=' || numtostr('%.2f', h_nds7); --  18  
        v_par11 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMVOZVRAT') then begin --   (  )
        v_id = -1; x_ext_doc_date = null; x_ext_docindex = null; v_date = null; v_str = ''; --            
        select indochead from PARTSPEC where dochead = :id rows 1 into :v_id;
        if (v_id is not null)
          then select docindex, doc_date, ext_doc_date, ext_docindex
                 from DOCHEAD where id_dochead = :v_id
               into :v_str, :v_date, :x_ext_doc_date, :x_ext_docindex;
        if (v_str is null) then v_str = '';
        if (v_date is null) then v_date = x_doc_date;
        if (x_ext_doc_date is null) then x_ext_doc_date = v_date;
        v_par1 = 'SMID=' || id;  --   
        v_par2 = 'SMINDEX=' || x_docindex;  --   
        v_par3 = 'EXTSMID=' || v_id;  --   
        v_par4 = 'EXTSMINDEX=' || v_str;  --   
        v_par5 = 'EXTID=' || x_ext_docindex; --     
        v_par6 = 'DOCDATE=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   
        v_par7 = 'SCHDATE=' || iif(x_ext_doc_date is null, '', datetostr('YYYYMMDD', x_ext_doc_date)); --    
        v_par8 = 'SCHMOV=' || iif(v_date is null, '', datetostr('YYYYMMDD', v_date)); --   
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par9 = 'SAPSTORE=' || v_str; -- - 
        v_str = ''; --     ()
        select add_param3_clients from CLIENTS where id_clients = :x_client_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par10 = 'SENDERID=' || v_str; -- - 
        v_par11 = 'DOCPRICE=' || numtostr('%.2f', h_totalrub); --   
        v_par12 = 'NDS10=' || numtostr('%.2f', h_nds1); --  10  
        v_par13 = 'NDS18=' || numtostr('%.2f', h_nds7); --  18  
        v_par14 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMSALE') then begin -- /  (  ;   ;    ;)
        v_par1 = 'SMID=' || id;  --   /
        v_par2 = 'SMINDEX=' || x_docindex;  --   /
        v_par3 = 'OPERTYPE=' || x_i_param1; -- (4, 3, 1)
        v_par4 = 'DOCDATE=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   /
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par5 = 'SAPDEB=' || v_str; -- - 
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par6 = 'SAPSTORE=' || v_str; -- - 
        v_par7 = 'DOCPRICE=' || numtostr('%.2f', h_totalrub); --   /
        v_dbl = 0;
        select totalrub from DOCTAX where id_dochead = :id and tax_kind = 0 into :v_dbl;
        if (v_dbl is null) then v_dbl = 0;
        v_par8 = 'DOCTAX=' || numtostr('%.2f', v_dbl); --    /
        v_par9 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMOVEOUT') then begin --   (     ;    )
        v_par1 = 'SMID=' || id;  --   
        v_par2 = 'SMINDEX=' || x_docindex;  --   
        v_par3 = 'MOVDATE=' || iif(x_ext_doc_date is null, '', datetostr('YYYYMMDD', x_ext_doc_date)); --    
        v_par4 = 'DOCDATE=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   
        v_str = ''; --      
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par5 = 'SAPSNDR=' || v_str; -- -  
        v_str = ''; --       ()
        select add_param4_clients from CLIENTS where id_clients = :x_client_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par6 = 'SAPRCVR=' || v_str; -- -  
        v_par7 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMOVEIN') then begin --   (     ;    )
        v_par1 = 'ID=' || x_ext_docindex; --    
        v_par2 = 'SMID=' || id;  --   
        v_par3 = 'SMINDEX=' || x_docindex;  --   
        v_par4 = 'MOVDATE=' || iif(x_ext_doc_date is null, '', datetostr('YYYYMMDD', x_ext_doc_date)); --    
        v_par5 = 'DOCDATE=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   
        v_par6 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMOVERECOUT') then begin -- /  (   )
        v_par1 = 'SMID=' || id;  --   /
        v_par2 = 'SMINDEX=' || x_docindex;  --   /
        v_par3 = 'DOCDATE=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   /
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        if (x_dockind = 0) then begin --  
          v_par4 = 'SAPRCVR=' || v_str; -- -  
          v_str = ''; --       ()
          select add_param3_clients from CLIENTS where id_clients = :x_client_index into :v_str;
          if (v_str is null) then v_str = '';
          v_par5 = 'SAPSNDR=' || v_str; -- -  
        end else begin              --  
          v_par4 = 'SAPSNDR=' || v_str; -- -  
          v_str = ''; --       ()
          select add_param4_clients from CLIENTS where id_clients = :x_client_index into :v_str;
          if (v_str is null) then v_str = '';
          v_par5 = 'SAPRCVR=' || v_str; -- -  
        end
        v_par6 = 'SMOPER=' || x_operation; -- 
      end else
      if (xml_kind = 'SMINVETORY') then begin -- /  (, , ,  , , )
        v_par1 = 'SMID=' || id;  --   /
        v_par2 = 'SMINDEX=' || x_docindex;  --   /
        v_par3 = 'DOCDATE=' || iif(x_doc_date is null, '', datetostr('YYYYMMDD', x_doc_date)); --   /
        v_str = ''; --     
        select add_param4_clients from CLIENTS where id_clients = :x_client2_index into :v_str;
        if (v_str is null) then v_str = '';
        v_par4 = 'SAPSTORE=' || v_str; -- - 
        v_par5 = 'TYPE=' || x_dockind; --  
        v_par6 = 'OPERTYPE=' || x_operation; -- 
        if (x_client_index = 948)
          then v_par7 = 'CLNTTYPE=1'; -- 948 
          else if (x_client_index = 6689)
                 then v_par7 = 'CLNTTYPE=2'; -- 6689 
                 else v_par7 = 'CLNTTYPE=0';
        v_par8 = 'SMOPER=' || x_operation; -- 
      end else
        tag_name = ''; --      

      o_id = :id;
      suspend;
    end

    if (s_articul > '') then begin
      v_par8 = ''; v_par9 = ''; v_par10 = ''; v_par11 = ''; v_par12 = ''; v_par13 = '';
      v_par14 = ''; v_par15 = '';
      --   
      tag_kind = 1; tag_name = 'POS';
      if (s_custom is null) then s_custom = '';
      v_str = ''; c_country = null; --     
      select add_param5, country from CARDSCLA where articul = :s_articul into :v_str, :c_country;
      if (v_str is null) then v_str = '';
      if (c_country is null) then c_country = -1;
      v_par1 = 'ID=' || v_str; -- - 
      v_par2 = 'QTY=' || numtostr('%.3f', s_quantity); -- 

      --         (    SAP) -
      --        
      --    doctype  1511 -         
      if (xml_kind = 'SMPRIHODOUT' and v_dt <> 1511) then begin
        s_pos_number = null;
        select pos_number from DOCSPEC where id_dochead = :v_id and articul = :s_articul into :s_pos_number;
        if (s_pos_number is null) then s_pos_number = -1;
        v_par3 = 'STRNO=' || s_pos_number; --    
      end else
        v_par3 = 'STRNO=' || s_pos_number; --  

      v_par4 = 'POSPRICE=' || numtostr('%.2f', s_quantity * s_pricerub); --  
      v_par5 = 'UINTPRICE=' || numtostr('%.2f', s_pricerub); --   
      v_par6 = 'POSTAX=' || numtostr('%.2f', s_nds); --   
      if (s_taxhead = 2) then v_str = '20'; else
      if (s_taxhead = 7) then v_str = '18'; else
      if (s_taxhead = 1) then v_str = '10'; else v_str = '';
      v_par7 = 'CODE=' || v_str;

      if (xml_kind = 'SMPRIHODOUT' or       --         (    SAP)
          xml_kind = 'SMPRIHOD') then begin --   (   S-Market)
        v_par8 = 'GTD=' || s_custom;
        if (s_country is null or s_country = -1) then s_country = c_country;
        v_str = '';
        select name_country from COUNTRY where id_country = :s_country into :v_str;
        if (v_str is null) then v_str = '';
        v_par9 = 'COUNTRY=' || v_str; -- 
      end else
      if (not(xml_kind = 'SMVOZVRAT' or    --   (  )
              xml_kind = 'SMSALE' or       -- /  (  ;   ;    ;)
              xml_kind = 'SMOVEOUT' or     --   (     ;    )
              xml_kind = 'SMOVEIN' or      --   (     ;    )
              xml_kind = 'SMOVERECOUT' or  -- /  (   )
              xml_kind  ='SMINVETORY'))    -- /  (, , ,  , , )
        then tag_name = ''; --  ,      
      suspend;
    end
  end
end^



create or alter procedure EGAIS_VIEW_REMAINS (
    OWNER    T_ID,
    REGISTER T_INT_VALUE)
returns (
    UTM               T_FID,
    ALC_CODE          T_EGAIS_CODE,
    REG_ID_A          T_STRING50,
    REG_ID_B          T_STRING50,
    QUANTITY          T_QUANTITY_NULL,
    REMAINS_MARKS     T_INT_VALUE,
    BOTTLING_DATE     T_DATE_NULL,
    ARTICUL           T_ARTICUL_NULL,
    NAME              T_FULL_NAME_NULL,
    CAPACITY          T_FLOAT,
    PRODUCT_VCODE     T_PRODUCT_CODE,
    SHORT_NAME        T_STRING64,
    FULL_NAME         T_STR_VALUE,
    ALC_VOLUME        T_FLOAT,
    PRODUCT_TYPE      T_FID,
    PRODUCT_TYPE_NAME T_STR5N,
    WB_UNIT_TYPE      T_FID,
    WB_UNIT_TYPE_NAME T_STR13,
    PCLIENT_REG_ID    T_EGAIS_CLIENT_CODE,
    PFULL_NAME        T_STR_VALUE,
    PSHORT_NAME       T_STRING64,
    PINN              T_INN,
    PKPP              T_KPP,
    PCOUNTRY          T_FID,
    PREGION_CODE      T_FID,
    PDESCRIPTION      T_WEB_ADR,
    ICLIENT_REG_ID    T_EGAIS_CLIENT_CODE,
    IFULL_NAME        T_STR_VALUE,
    ISHORT_NAME       T_STRING64,
    IINN              T_INN,
    IKPP              T_KPP,
    ICOUNTRY          T_FID,
    IREGION_CODE      T_FID,
    IDESCRIPTION      T_WEB_ADR,
    UNMARKED          T_INT_BOOLEAN_NULL)
AS
begin --    
  for
    select r.UTM, r.ALC_CODE, r.REG_ID_A, r.REG_ID_B, r.QUANTITY, ra.BOTTLING_DATE, cs.ARTICUL, cs.NAME,
           c.CAPACITY, c.PRODUCT_VCODE, c.SHORT_NAME, c.FULL_NAME, c.ALC_VOLUME,
           c.PRODUCT_TYPE, decode(c.PRODUCT_TYPE, 0, '', 1, '', 2, '', 3, '') as PRODUCT_TYPE_NAME,
           c.WB_UNIT_TYPE, decode(c.WB_UNIT_TYPE, 0, '', 1, '') as WB_UNIT_TYPE_NAME,
           p.CLIENT_REG_ID as pCLIENT_REG_ID, p.FULL_NAME as pFULL_NAME, p.SHORT_NAME as pSHORT_NAME, coalesce(p.INN, p.UNP, p.RNN) as pINN, 
           p.KPP as pKPP, p.COUNTRY as pCOUNTRY, p.REGION_CODE as pREGION_CODE, p.DESCRIPTION as pDESCRIPTION,
           i.CLIENT_REG_ID as iCLIENT_REG_ID, i.FULL_NAME as iFULL_NAME, i.SHORT_NAME as iSHORT_NAME, coalesce(i.INN, i.UNP, i.RNN) as iINN, 
           i.KPP as iKPP, i.COUNTRY as iCOUNTRY, i.REGION_CODE as iREGION_CODE, i.DESCRIPTION as iDESCRIPTION
      from EGAIS_REMAINS r
      left join EGAIS_REG_ID_A ra on ra.REG_ID_A = r.REG_ID_A
      left join EGAIS_CARDS_LINK k on r.ALC_CODE = k.ALC_CODE
      left join CARDSCLA cs on cs.ARTICUL = k.ARTICUL
      left join EGAIS_CARDS c on c.ALC_CODE = r.ALC_CODE
      left join EGAIS_PRODUCERS p on p.CLIENT_REG_ID = c.PRODUCER
      left join EGAIS_PRODUCERS i on i.CLIENT_REG_ID = ra.EGAIS_CODE
     where r.UTM = :OWNER
       and r.REGISTER = :REGISTER
      into  :UTM,            :ALC_CODE,           :REG_ID_A,      :REG_ID_B,    :QUANTITY,     :BOTTLING_DATE,  :ARTICUL,  :NAME,
            :CAPACITY,       :PRODUCT_VCODE,      :SHORT_NAME,    :FULL_NAME,   :ALC_VOLUME,
            :PRODUCT_TYPE,   :PRODUCT_TYPE_NAME,
            :WB_UNIT_TYPE,   :WB_UNIT_TYPE_NAME,
            :PCLIENT_REG_ID, :PFULL_NAME,         :PSHORT_NAME,   :PINN,
            :PKPP,           :PCOUNTRY,           :PREGION_CODE,  :PDESCRIPTION,
            :ICLIENT_REG_ID, :IFULL_NAME,         :ISHORT_NAME,   :IINN,
            :IKPP,           :ICOUNTRY,           :IREGION_CODE,  :IDESCRIPTION
  do
  begin
    select count(*)
      from EGAIS_REMAINS_MARKS
     where RFU2 = :REG_ID_B
       and UTM = :OWNER
      into :REMAINS_MARKS;

    select UNMARK
      from VID_PROD
     where upper(KOD collate PXW_CYRL) = :PRODUCT_VCODE
      rows 1
      into :UNMARKED;

    suspend;
  end
end^




create or alter procedure EGAIS_MAKE_TRANSFER_ACT_FETCH (
    ACT_ID T_ID,
    OWNER  T_ID)
returns (
    ARTICUL  T_ARTICUL_NULL,
    ALC_CODE T_ALC_CODE,
    REG_A    T_STRING50,
    REG_B    T_STRING50,
    QUANTITY T_QUANTITY_NULL,
    FERROR   T_FID)
AS
declare variable CAP_COUNT T_FID;
declare variable FREMAINS double precision;  --    
declare variable FQUANTITY double precision; --    
declare variable MREMAINS double precision;  --    
declare variable MQUANTITY double precision; --    
begin
  FERROR = 0;
  for --   
    select ex.ARTICUL, ex.ALC_CODE, ex.FORM_A, ex.FORM_B, ex.QUANTITY, re.QUANTITY
      from EGAIS_BALANCE_DOCSPEC_EXT ex
      join EGAIS_BALANCE_DOCSPEC bds on bds.DOCHEAD = ex.DOCHEAD
                                    and bds.ARTICUL = ex.ARTICUL
      join EGAIS_REMAINS re on re.UTM = :OWNER
                           and re.ALC_CODE = ex.ALC_CODE
                           and re.REG_ID_A = ex.FORM_A
                           and re.REG_ID_B = ex.FORM_B
                           and re.REGISTER = 1
     where bds.DOCHEAD = :ACT_ID
       into :ARTICUL, :ALC_CODE, :REG_A, :REG_B, :FREMAINS, :FQUANTITY
  do
  begin
-- <     SM-3582
    select count(*)                --       .
      from EGAIS_MARKS
     where DOC_EGAIS = :ACT_ID
       and DOC_KIND = 3
       and RFU2 = :REG_B
       and MARK_TYPE = 2
      into :MQUANTITY;

    select count(*)
      from EGAIS_REMAINS_MARKS
     where RFU2 = :REG_B
       and MARK_TYPE = 2
      into :MREMAINS;

    QUANTITY = minvalue(FREMAINS - MREMAINS, FQUANTITY - MQUANTITY);
--    QUANTITY = minvalue(FREMAINS, FQUANTITY);
-- >
    select RESULT
      from EGAIS_CHECK_CARD_CAPACITY(:ARTICUL)
      into :CAP_COUNT;

    if (CAP_COUNT > 1) then
      FERROR = 1;

    if (QUANTITY > 0 or FERROR = 1) then
      suspend;

    if (FERROR = 1) then
      exit;
  end
end^




set term ; ^



-- SM-3587

CREATE INDEX EGAIS_REMAINS_IDX_REG_ID_B ON EGAIS_REMAINS (REG_ID_B);


set term ^ ;

CREATE OR ALTER TRIGGER EGAIS_MARKS_BIU_TYPE FOR EGAIS_MARKS
ACTIVE BEFORE INSERT OR UPDATE POSITION 10
as
begin
--  in autonomous transaction do
--    insert into LOGG values ('  DOC_SM='||coalesce(new.DOC_SM,'NULL')||
--                             '  DOC_EGAIS='||coalesce(new.DOC_EGAIS,'NULL')||
--                             '  DOC_KIND='||coalesce(new.DOC_KIND,'NULL')||
--                             '  MARK='||coalesce(new.MARK,'NULL')||
--                             '  RFU2='||coalesce(new.RFU2,'NULL'));

  --new.RFU2 = nullif(new.RFU2, '');

  --    68  150.
  if (new.MARK is null) then new.MARK_TYPE = null; else
  if (char_length(new.MARK) = 68) then new.MARK_TYPE = 1; else
  if (char_length(new.MARK) = 150) then new.MARK_TYPE = 2; else
    exception EGAIS_MARKS_LEN;

  --   2      .
  if (new.RFU2 is not null) then
  if (exists(select 1
               from EGAIS_MARKS
              where RFU2 = new.RFU2
                and (inserting or MARK <> old.MARK)
                and DOC_SM = new.DOC_SM
                and DOC_EGAIS = new.DOC_EGAIS
                and DOC_KIND = new.DOC_KIND
                and MARK_TYPE <> new.MARK_TYPE)) then
    exception EGAIS_MARKS_TYPE;

  if (coalesce(new.NUM_POS,-1) <> -1 and new.DOC_KIND <> 9) then
  if (exists(select 1
               from EGAIS_MARKS
              where (inserting or MARK <> old.MARK)
                and MARK_TYPE <> new.MARK_TYPE
                and DOC_SM = new.DOC_SM
                and DOC_EGAIS = new.DOC_EGAIS
                and DOC_KIND = new.DOC_KIND
                and NUM_POS = new.NUM_POS )) then
    exception EGAIS_MARKS_TYPE;
end^

set term ; ^




-- SM-3591

set term ^ ;

create or alter procedure EGAIS_CORRECT_TRANSFER (
    DOC_ID          T_ID,
    PREPARE_TO_SEND T_INT_VALUE = 0)
AS
declare variable OWNER    T_FID;
declare variable KIND     T_FID;
declare variable DOC_KIND T_FID;
declare variable STATE    T_FID;
declare variable ALC_CODE T_ALC_CODE;
declare variable RFU1     T_STRING50;
declare variable RFU2     T_STRING50;
declare variable ARTICUL  T_ARTICUL_NULL;
declare variable POS_NUM  T_INT_VALUE;
begin
  --         ,
  --     .
  --      .
  --   ,   .
  select OWNER, KIND, DOC_KIND, EGAIS_STATE
    from EGAIS_TRANSFER
   where ID = :DOC_ID
    into :OWNER, :KIND, :DOC_KIND, :STATE;

  if (DOC_KIND = 0 and STATE = 1) then
  begin
  
    for
      select x.ALC_CODE, x.RFU1, x.RFU2
        from EGAIS_TRANSFER_SPEC_EXT x
       where x.DOC_ID = :DOC_ID
        into :ALC_CODE, :RFU1, :RFU2
    do
    begin
      if (not exists(select 1
                       from EGAIS_CARDS_LINK cl
                       join EGAIS_REMAINS re on re.UTM = :OWNER
                                            and re.REGISTER = :KIND
                                            and re.ALC_CODE = cl.ALC_CODE
                                            and re.REG_ID_A = coalesce(:RFU1,'')
                                            and re.REG_ID_B = coalesce(:RFU2,'')
                                            and (re.QUANTITY /*- (select count(*) from EGAIS_REMAINS_MARKS where RFU2 = re.REG_ID_B)*/) > 0
                      where cl.ALC_CODE = :ALC_CODE)) then
        delete
          from EGAIS_TRANSFER_SPEC_EXT
         where DOC_ID = :DOC_ID
           and ALC_CODE = :ALC_CODE
           and RFU1 is not distinct from :RFU1
           and RFU2 is not distinct from :RFU2;
    end
  
  
    if (PREPARE_TO_SEND = 0) then
      for
        select re.ALC_CODE, re.REG_ID_A, re.REG_ID_B, cl.ARTICUL
          from EGAIS_REMAINS re
          join EGAIS_CARDS_LINK cl on cl.ALC_CODE = re.ALC_CODE
          join EGAIS_TRANSFER_SPEC ts on ts.ARTICUL = cl.ARTICUL
                                     and ts.DOC_ID = :DOC_ID
         where re.UTM = :OWNER
           and re.REGISTER = :KIND
           and (re.QUANTITY /*- (select count(*) from EGAIS_REMAINS_MARKS where RFU2 = re.REG_ID_B)*/) > 0
          into :ALC_CODE, :RFU1, :RFU2, :ARTICUL
      do
      begin
        if (not exists(select 1
                         from EGAIS_TRANSFER_SPEC_EXT
                        where DOC_ID = :DOC_ID
                          and ARTICUL = :ARTICUL
                          and ALC_CODE = :ALC_CODE
                          and coalesce(RFU1,'') = :RFU1
                          and coalesce(RFU2,'') = :RFU2)) then
        begin
          POS_NUM = 0;
          select coalesce(max(POS_NUM), 0)
            from EGAIS_TRANSFER_SPEC_EXT
           where DOC_ID = :DOC_ID
            into :POS_NUM;
    
          insert into EGAIS_TRANSFER_SPEC_EXT (DOC_ID, POS_NUM, ARTICUL, ALC_CODE, RFU1, RFU2, QUANTITY)
               values (:DOC_ID, :POS_NUM+1, :ARTICUL, :ALC_CODE, NullIf(:RFU1,''), NullIf(:RFU2,''), 0);
        end
      end

    if (PREPARE_TO_SEND = 1) then
    begin
      in autonomous transaction do
        insert into TMP_LOG(KIND, LEVEL, TEXT) values (1, 5, '  ');
  
      delete
        from EGAIS_TRANSFER_SPEC_EXT
       where DOC_ID = :DOC_ID
         and QUANTITY < 1e-9;

      delete
        from EGAIS_TRANSFER_SPEC_RFU
       where DOC_ID = :DOC_ID
         and QUANTITY < 1e-9;
    end
  end
end^

set term ; ^



commit work;
